% Compute gradient relative to weights

for subnet=1:ninputs
   for column=1:ninputs
      grad12{subnet}(:,column) = sum(jback2i{subnet,column},2);
      grad23{subnet}(:,1:nhidden) = grad23{subnet}(:,1:nhidden) + jback3{subnet,column} * jacob2o{subnet,column}';
      grad13{subnet}(:,column) = sum(jback3{subnet,column},2);
      grad34{subnet}(:,1) = grad34{subnet}(:,1) + jback4i{subnet,column} * jacob3{subnet,column}';
      grad45{subnet}(:,1:nextra) = grad45{subnet}(:,1:nextra) + jback5{column}(subnet,:) * jacob4o{subnet,column}';
      grad35{subnet}(:,1) = grad35{subnet}(:,1) + jback5{column}(subnet,:) * jacob3{subnet,column}';
%      fprintf('subnet= %2i col= %2i grad45= %7.3f %7.3f %7.3f %7.3f\n', subnet, column, grad45{subnet});
   end
   grad12{subnet} = grad12{subnet} + back2{subnet} * output1';
   grad12{subnet}(:,1:ninputs) = grad12{subnet}(:,1:ninputs) + wdecayf12 * weight12{subnet}(:,1:ninputs);
   grad23{subnet} = grad23{subnet} + back3{subnet} * output2{subnet}';
   grad23{subnet}(:,1:nhidden) = grad23{subnet}(:,1:nhidden) + wdecayf23 * weight23{subnet}(:,1:nhidden);
   grad13{subnet} = grad13{subnet} + back3{subnet} * output1';
   grad34{subnet} = grad34{subnet} + back4{subnet} * output3{subnet}';
   grad34{subnet}(:,1) = grad34{subnet}(:,1) + wdecayf34 * weight34{subnet}(:,1);
   grad45{subnet} = grad45{subnet} + back5{subnet} * output4{subnet}';
   grad35{subnet} = grad35{subnet} + back5{subnet} * output3{subnet}';
end

grad13{1}(2) = grad13{1}(2) + wdecayf13 * weight13{1}(2);
grad13{2}(1) = grad13{2}(1) + wdecayf13 * weight13{2}(1);

% The following, using 'signfact', is only for the see through problem

grad12{1}(:,1) = grad12{1}(:,1) + signfact * min(weight12{1}(:,1),0);
grad12{1}(:,2) = grad12{1}(:,2) + signfact * max(weight12{1}(:,2),0);
grad12{2}(:,2) = grad12{2}(:,2) + signfact * min(weight12{2}(:,2),0);
grad12{2}(:,1) = grad12{2}(:,1) + signfact * max(weight12{2}(:,1),0);
grad23{1} = grad23{1} + signfact * min(weight23{1},0);
grad23{2} = grad23{2} + signfact * min(weight23{2},0);

% Apply symmetry condition

if epochs <= symepochs
   i1 = [1 2 3];
   i2 = [2 1 3];

   grad12{1}(:,i1) = grad12{1}(:,i1) + grad12{2}(:,i2);
   grad12{2}(:,i2) = grad12{1}(:,i1);

   grad23{1} = grad23{1} + grad23{2};
   grad23{2} = grad23{1};

   grad13{1}(:,i1) = grad13{1}(:,i1) + grad13{2}(:,i2);
   grad13{2}(:,i2) = grad13{1}(:,i1);
end



