% Create and initialize network variables

ident = eye(ninputs+1);

i1 = [1 2 3];
i2 = [2 1 3];
weight12{1} = (rand(nhidden,ninputs+1) - .5) * (2 * weightrange13);
weight12{2}(:,i2) = weight12{1}(:,i1);
weight23{1} = zeros(1,nhidden);                             % nonlinear influence initialized to zero
weight23{2} = weight23{1};
weight13{1} = ident(1,:);
weight13{2} = ident(2,:);


for subnet=1:ninputs   
    if barrierfact ==0
        weight34{subnet} = rand(nextra,2) * weightrange35;                 % 34 and 45 have to be positive
        weight45{subnet} = rand(1,nextra) * weightrange35;
        weight35{subnet} = [0 0];
    else
        weight34{subnet} = (rand(nextra,2) - 0) * weightrange35;
        weight45{subnet} = (rand(1,nextra) - 0) * weightrange35;
        weight35{subnet} = [weightrange35 0];
    end 
    
   grad12{subnet} = zeros(size(weight12{subnet}));         % not really necessary, except
   grad23{subnet} = zeros(size(weight23{subnet}));         % for the test of grad45{1}
   grad13{subnet} = zeros(size(weight13{subnet}));         % in 'testcost'
   grad34{subnet} = zeros(size(weight34{subnet}));
   grad45{subnet} = zeros(size(weight45{subnet}));
   grad35{subnet} = zeros(size(weight35{subnet}));
   
   grad12old{subnet} = zeros(size(weight12{subnet}));
   grad23old{subnet} = zeros(size(weight23{subnet}));
   grad13old{subnet} = zeros(size(weight13{subnet}));
   grad34old{subnet} = zeros(size(weight34{subnet}));
   grad45old{subnet} = zeros(size(weight45{subnet}));
   grad35old{subnet} = zeros(size(weight35{subnet}));
   
   z12{subnet} = zeros(size(weight12{subnet}));
   z23{subnet} = zeros(size(weight23{subnet}));
   z13{subnet} = zeros(size(weight13{subnet}));
   z34{subnet} = zeros(size(weight34{subnet}));
   z45{subnet} = zeros(size(weight45{subnet}));
   z35{subnet} = zeros(size(weight35{subnet}));
   
   eta12{subnet} = ones(size(weight12{subnet})) * eta0123;
   eta23{subnet} = ones(size(weight23{subnet})) * eta0123;
   eta13{subnet} = ones(size(weight13{subnet})) * eta013;
   eta34{subnet} = ones(size(weight34{subnet})) * eta035;
   eta45{subnet} = ones(size(weight45{subnet})) * eta035;
   if barrierfact == 0
      eta35{subnet} = zeros(size(weight35{subnet}));
   else
      eta35{subnet} = ones(size(weight35{subnet})) * eta035;
   end
end

mincost = 1E20;
cost = mincost;
epochs = 0;
falseepochs = 0;


