% Plot the data

% The plotting window should be resized so that the left-hand and middle plots are square.

if mod(epochs, ndisp)==0
   figure(1)
   clf
   a1 = axes('position',[.03,.1,.29,.85]);
   a2 = axes('position',[.36,.1,.29,.85]);
   a3 = axes('position',[.69,.56,.29,.38]);
   a4 = axes('position',[.69,.1,.29,.38]);
   
   % Left:   Scatter plot of separated components (y)
   
   if ntrain >= 2000
       axes(a1), cla, plot(input3{ploth}, input3{plotv}, 'b.', 'markersize', 1), axis tight
   else
       axes(a1), cla, plot(input3{ploth}, input3{plotv}, 'b.'), axis tight
   end
   
   
   % Center: Scatter plot of auxiliary outputs (z)

   if ntrain >=2000
       axes(a2), cla, plot(output{ploth}, output{plotv}, 'b.', 'markersize', 1), axis([-1 1 -1 1])
   else
       axes(a2), cla, plot(output{ploth}, output{plotv}, 'b.'), axis([-1 1 -1 1])
   end

   
   % Right:  Cumulative probability functions learned by the output MLPs
   %         Note: These are scaled between -1 and 1, instead of between 0 and 1
   
   compdist
   axes(a3), cla, plot(cgrid{ploth}, outputd{ploth}, 'b-'), axis tight
   axes(a4), cla, plot(cgrid{plotv}, outputd{plotv }, 'b-'), axis tight 
   
end
